import { HttpMethod } from "aws-cdk-lib/aws-lambda";
import { toCdkDuration } from "./duration.js";
export function buildCorsConfig(cors) {
    // Handle cors: false
    if (cors === false) {
        return;
    }
    // Handle cors: true | undefined
    else if (cors === undefined || cors === true) {
        return {
            allowedHeaders: ["*"],
            allowedMethods: [HttpMethod.ALL],
            allowedOrigins: ["*"],
        };
    }
    // Handle cors: FunctionUrlCorsOptions
    else {
        return {
            allowCredentials: cors.allowCredentials,
            allowedHeaders: cors.allowHeaders,
            allowedMethods: (cors.allowMethods || []).map((method) => method === "*"
                ? HttpMethod.ALL
                : HttpMethod[method]),
            allowedOrigins: cors.allowOrigins,
            exposedHeaders: cors.exposeHeaders,
            maxAge: cors.maxAge && toCdkDuration(cors.maxAge),
        };
    }
}
